////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for MetaTrader 5                                   //
// Multifunctional information system for mechanical trading                  //
// Copyright (c) 2005-2011 Interesting                                        //
// Mail: MD-Interesting@Mail.ru                                               //
////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for trading on market Forex                        //
// Template for creating an expert for the terminal MetaTrader 5              //
// Unit: Forum                                                                //
////////////////////////////////////////////////////////////////////////////////
// Version:      2.0                                                          //
// Version File: 2.0.0.0                                                      //
// File name: Forum.mq5                                                       //
////////////////////////////////////////////////////////////////////////////////
//                                  Property                                  //
////////////////////////////////////////////////////////////////////////////////
#property description "Mechanical trade system for trading on market Forex"
#property description "Version File: 2.0.0.0"
#property copyright   "interesting"
#property link        "Mail: MD-interesting@Mail.ru"
#property version     "2.00"
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//class CShape
class CShape
// 
{  
protected: 

int            m_type; //  
int            m_xpos; // X -   
int            m_ypos; // Y -   

public:

void           CShape(){m_type=0;};        // ,   
int            GetType(){return(m_type);}; //   

void           SetPosX(int s){m_xpos=s;};
int            GetPosX(){return(m_xpos);};

void           SetPosY(int s){m_ypos=s;};
int            GetPosY(){return(m_ypos);};

virtual double GetArea(){return (0); }//   

virtual void Free(CShape *p)
        {
          if(CheckPointer(p)==POINTER_DYNAMIC)
          {
          delete p;
          }
        }

};
//****************************************************************************//
//class CCircle
class CCircle : public CShape
//  
{
private:

double m_radius;  //  

public:

void     CCircle(){m_type=1;};  // ,   1 

void     SetRadius(double r){m_radius=r;}; //  
double   GetRadius(){return(m_radius);}    //  

virtual double GetArea(){return (3.141592*m_radius*m_radius);} // 

};
//****************************************************************************//
//class CSquare
class CSquare : public CShape
//  
{
private:

double m_square_side; //  

public:

void CSquare(){m_type=2;}; // ,   2 

void    SetSide(double s){m_square_side=s;}; //  
double  GetSide(){return(m_square_side);};   //  

virtual double  GetArea(){return (m_square_side*m_square_side);}// 

};
////////////////////////////////////////////////////////////////////////////////
CShape *ArrShapes[10]; //   CShape
////////////////////////////////////////////////////////////////////////////////
//             Global variables, used in working the trade system             //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//                                Trade expert                                //
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
//                       Expert initialization function                       //
//****************************************************************************//
int OnInit()
{
//----------------------------------------------------------------------------//
//Work variables
string Messages;

int Random;
int Result = 0; //Returned importance
//----------------------------------------------------------------------------//

  for (int i=0; i<10;i++)  
  //   
  {
  Random=rand()%2;
  
    switch(Random)
    {
      case 0:
      {
      ArrShapes[i] = new CCircle;
      ArrShapes[i].SetPosX(100);
      ArrShapes[i].SetPosY(100);

      Messages = "   ";
      break;
      }
      case 1:
      {
      ArrShapes[i] = new CSquare;
      ArrShapes[i].SetPosX(300);
      ArrShapes[i].SetPosY(100);
      Messages = "   ";
      break;
      }
    }  

  //    
  Print("  ",ArrShapes[i].GetType()," X ",ArrShapes[i].GetPosX()," Y ",ArrShapes[i].GetPosY(),Messages,ArrShapes[i].GetArea());
  };
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                      Expert deinitialization function                      //
//****************************************************************************//
//Procedure OnDeinit
void OnDeinit(const int reason)
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//
  for (int i=0; i<ArraySize(ArrShapes);i++)  
  {
  ArrShapes[i].Free(ArrShapes[i]);
  }  
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                           Expert Ticks function                            //
//****************************************************************************//
//Event OnTick
void OnTick()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                           Expert Timer function                            //
//****************************************************************************//
//Event OnTimer
void OnTimer()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//


//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                         Expert Book Event function                         //
//****************************************************************************//
//Event OnBookEvent
void OnBookEvent(const string& symbol)
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                        Expert Chart Event function                         //
//****************************************************************************//
//Event OnChartEvent
void OnChartEvent(const int id,
                  const long& lparam,
                  const double& dparam,
                  const string& sparam
                  )
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                          Processing user events                            //
//----------------------------------------------------------------------------//
  if(id>CHARTEVENT_CUSTOM)
  //User event is received
  {
  }
//----------------------------------------------------------------------------//  
}
//****************************************************************************//
//                           Expert trade function                            //
//****************************************************************************//
//Event OnTrade
void OnTrade()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//  
}
//****************************************************************************//
//                           Expert tester function                           //
//****************************************************************************//
//Event OnTester
double OnTester()
{
//----------------------------------------------------------------------------//
//Work variables
double Result = 0;
//----------------------------------------------------------------------------//

Result = 0;

ResetLastError();

//Processing

//Checking for presence of the errors
  if(_LastError!=0)
  {
  Result = -1;  
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                               Implementation                               //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////